<?php
/**
 * Copyright 2018 Kacper Donat
 *
 * @author Kacper "Kadet" Donat <kacper@kadet.net>
 *
 * Full license available in separate LICENSE file
 */

namespace Kadet\Functional\Predicates;

use Kadet\Functional\Predicate;
use function Kadet\Functional\predicate;

/**
 * @param $expected
 *
 * @return \Kadet\Functional\Predicate
 * @throws \Exception
 */
function equals($expected): Predicate
{
    return predicate(function ($value) use ($expected) {
        return $expected == $value;
    });
}

/**
 * @param $expected
 *
 * @return \Kadet\Functional\Predicate
 * @throws \Exception
 */
function same($expected): Predicate
{
    return predicate(function ($value) use ($expected) {
        return $value === $expected;
    });
}

/**
 * @param $expected
 *
 * @return \Kadet\Functional\Predicate
 * @throws \Exception
 */
function gt($expected): Predicate
{
    return predicate(function ($value) use ($expected) {
        return $value > $expected;
    });
}

/**
 * @param $expected
 *
 * @return \Kadet\Functional\Predicate
 * @throws \Exception
 */
function ge($expected): Predicate
{
    return predicate(function ($value) use ($expected) {
        return $value >= $expected;
    });
}

/**
 * @param $expected
 *
 * @return \Kadet\Functional\Predicate
 * @throws \Exception
 */
function lt($expected): Predicate
{
    return predicate(function ($value) use ($expected) {
        return $value < $expected;
    });
}

/**
 * @param $expected
 *
 * @return \Kadet\Functional\Predicate
 * @throws \Exception
 */
function le($expected): Predicate
{
    return predicate(function ($value) use ($expected) {
        return $value <= $expected;
    });
}
